﻿using System.Collections.Generic;

namespace Dexter.Plugins.SelectiveTwitter {
	internal static class ConfigurationHelper {
		public static Configuration GetConfiguration {
			get {
				Configuration configuration = new Configuration();

				Hashtag javascriptCategory = new Hashtag();
				javascriptCategory.CategoryName = "Javascript";
				javascriptCategory.HashTags = new string[] {"#javascript", "#js"};

				Hashtag html5Gategory = new Hashtag();
				html5Gategory.CategoryName = "HTML5";
				html5Gategory.HashTags = new string[] {"#html5", "#css3", "#ecmascript"};

				Hashtag webDevCategory = new Hashtag();
				webDevCategory.CategoryName = "WebDev";
				webDevCategory.HashTags = new string[] {"#aspnetmvc", "#aspnet", "#ror", "#webdev"};

				configuration.CreateRecapPost = true;
				configuration.FetchMinutesFrequency = 10;
				configuration.Categories = new List<Hashtag>();
				configuration.Categories.Add(javascriptCategory);
				configuration.Categories.Add(html5Gategory);
				configuration.Categories.Add(webDevCategory);

				configuration.GrabCriteria = new GrabCriteria();
				configuration.GrabCriteria.HashTags = new[] {"tech"};
				configuration.GrabCriteria.Mentions = new[] {"@zite"};
				configuration.Owner = "imperugo";
				configuration.PageTitle = "Linkflood";
				configuration.PageSlug = "Linkflood";
				configuration.SubPageTitleFormat = "Linkflood - {0} -";
				configuration.SubPageSlugFormat = "Linkflood-{0}";

				return configuration;
			}
		}
	}
}