﻿using Dexter.Dependency;
using Dexter.Dependency.Installation;

namespace Dexter.Caching.AppFabric.Installer {
	public class Installer : ILayerInstaller {
		#region ILayerInstaller Members

		/// <summary>
		/// 	Installs all the component needed by the assembly.
		/// </summary>
		/// <param name = "container">The container.</param>
		public void ServiceRegistration ( IDexterContainerRegister container ) {

			container.Register<AppFabricCacheFactory, AppFabricCacheFactory> ( "AppFabricCacheFactory", new AppFabricCacheFactory ( ), LifeCycle.Singleton );
			container.Register<ICacheProvider, AppFabricCacheProvider> ( "AppFabricCacheProvider", LifeCycle.Singleton );
		}

		/// <summary>
		/// 	Setups the service.
		/// </summary>
		/// <param name = "container">The container.</param>
		public void ServiceRegistrationComplete ( IDexterContainerResolver container ) { }

		/// <summary>
		/// 	Setups the service.
		/// </summary>
		/// <param name = "container">The container.</param>
		public void ApplicationStarted ( IDexterContainerResolver container ) { }

		#endregion
	}
}