﻿using Dexter.Dependency;
using Dexter.Dependency.Installation;

namespace Dexter.Caching.AspNet.Installer {
	public class Installer : ILayerInstaller {
		#region ILayerInstaller Members

		/// <summary>
		/// 	Installs all the component needed by the assembly.
		/// </summary>
		/// <param name = "container">The container.</param>
		public void ServiceRegistration ( IDexterContainerRegister container ) {
			container.Register<ICacheProvider, AspNetCacheProvider> ( "AspNetCacheProvider", LifeCycle.Singleton );
		}

		/// <summary>
		/// 	Setups the service.
		/// </summary>
		/// <param name = "container">The container.</param>
		public void ServiceRegistrationComplete ( IDexterContainerResolver container ) { }

		/// <summary>
		/// 	Setups the service.
		/// </summary>
		/// <param name = "container">The container.</param>
		public void ApplicationStarted ( IDexterContainerResolver container ) { }

		#endregion
	}
}