﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		GenericEventArgsWithOneParameter.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            GenericEventArgsWithOneParameter.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion
 
namespace Dexter.Core.EventArgs
{
	#region Usings

	using System;

	#endregion

	public class GenericEventArgsWithOneParameter<T, K> : EventArgs
	{
		/// <summary>
		/// Initializes a new instance of the <see cref="GenericEventArgsWithOneParameter&lt;T, K&gt;"/> class.
		/// </summary>
		/// <param name="returnObject">The return object.</param>
		/// <param name="parameter">The parameter.</param>
		public GenericEventArgsWithOneParameter(T returnObject, K parameter) {
			Parameter = parameter;
			Objects = returnObject;
		}

		/// <summary>
		/// Gets or sets the parameter.
		/// </summary>
		/// <value>The parameter.</value>
		public K Parameter { get; set; }

		/// <summary>
		/// Gets or sets the object.
		/// </summary>
		/// <value>The object.</value>
		public T Objects { get; set; }
	}
}
