﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		IKeyBuilder.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            IKeyBuilder.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion

using System;
using System.Collections.Generic;

namespace Dexter.Core.Keys {
	/// <summary>
	/// The contract for Key builder service
	/// </summary>
	public interface IKeyBuilder {
		/// <summary>
		/// Creates an unique key for the specified string.
		/// </summary>
		/// <param name="value">The generate from.</param>
		///<exception cref="ArgumentNullException"> If <paramref name="value"/> is <c>null</c> or <c>empty</c>.</exception>
		string Create ( string value );

		/// <summary>
		/// Creates an unique key for the specified strings.
		/// </summary>
		/// <param name="values">The generate from.</param>
		///<exception cref="ArgumentNullException"> If <paramref name="values"/> is <c>null</c>.</exception>
		string Create ( IEnumerable<string> values );
	}
}
