﻿using System.Web;
using Castle.MicroKernel.Lifestyle;
using Dexter.Dependency.Installation;

namespace Dexter.Dependency.Castle.Installer {
	public class CastleInstaller : ILayerInstaller {
		#region ILayerInstaller Members

		/// <summary>
		/// 	Installs all the component needed by the assembly.
		/// </summary>
		/// <param name = "container">The container.</param>
		public void ServiceRegistration ( IDexterContainerRegister container ) {
			container.Register <IHttpModule , PerWebRequestLifestyleModule> ( "PerWebRequestLifestyleModule" , LifeCycle.Singleton );
			//container.Register<IHttpModule, NhibernateSessionModule> ( "NhibernateSessionModule", LifeCycle.Singleton );
		}

		/// <summary>
		/// 	Setups the service.
		/// </summary>
		/// <param name = "container">The container.</param>
		public void ServiceRegistrationComplete ( IDexterContainerResolver container ) { }

		/// <summary>
		/// 	Setups the service.
		/// </summary>
		/// <param name = "container">The container.</param>
		public void ApplicationStarted ( IDexterContainerResolver container ) { }

		#endregion
	}
}