﻿using System;

namespace Dexter.Dependency {
	/// <summary>
	/// 	This is the interface to generate concrete IoC engine.
	/// </summary>
	public interface IDexterContainerFactory {
		/// <summary>
		/// 	Creates this instance.
		/// </summary>
		/// <returns>An instance of the Container</returns>
		IDexterContainer Create ();

		/// <summary>
		/// Creates the installer.
		/// </summary>
		/// <returns></returns>
		IDexterInstaller CreateInstaller ( );

		/// <summary>
		/// 	Creates this instance.
		/// </summary>
		/// <param name = "configuration">The configuration.</param>
		/// <returns>An instance of the Container</returns>
		IDexterContainer Create ( String configuration );
	}
}