﻿using System;
using Dexter.Domain.Model;

namespace Dexter.Domain.Exceptions {
	/// <summary>
	/// This exception will raise when a error occurred on the default <see cref="Category"/>.
	/// </summary>
	public class DefaultCategoryException : SystemException {
		/// <summary>
		/// 	Initializes a new instance of the <see cref = "DefaultCategoryException" /> class.
		/// </summary>
		public DefaultCategoryException ( ) {}

		/// <summary>
		/// 	Initializes a new instance of the <see cref = "DefaultCategoryException" /> class.
		/// </summary>
		/// <param name = "message">The message.</param>
		public DefaultCategoryException ( string message ) : base ( message ) {}

		/// <summary>
		/// 	Initializes a new instance of the <see cref = "DefaultCategoryException" /> class.
		/// </summary>
		/// <param name = "message">The message.</param>
		/// <param name = "innerException">The inner exception.</param>
		public DefaultCategoryException ( string message , Exception innerException ) : base ( message , innerException ) {}
	}
}
