﻿using System;
using Dexter.Domain.Model;

namespace Dexter.Domain.Exceptions {
	/// <summary>
	/// This exception will raise when a error when an invalid <see cref="Item"/> will associate to a <see cref="Category"/>.
	/// </summary>
	public class InvalidItemCategoryException : SystemException {
		/// <summary>
		/// Initializes a new instance of the <see cref="InvalidItemCategoryException"/> class.
		/// </summary>
		public InvalidItemCategoryException ( ) {}

		/// <summary>
		/// Initializes a new instance of the <see cref="InvalidItemCategoryException"/> class.
		/// </summary>
		/// <param name="message">The message.</param>
		public InvalidItemCategoryException ( string message ) : base ( message ) {}

		/// <summary>
		/// Initializes a new instance of the <see cref="InvalidItemCategoryException"/> class.
		/// </summary>
		/// <param name="message">The message.</param>
		/// <param name="innerException">The inner exception.</param>
		public InvalidItemCategoryException ( string message , Exception innerException ) : base ( message , innerException ) {}
	}
}
