﻿using System;
using Dexter.Domain.Model;

namespace Dexter.Domain.Exceptions {

	/// <summary>
	/// This exception will raise when a error when an invalid slug will associated to <see cref="Item"/>.
	/// </summary>
	public class InvalidItemSlugException : SystemException {
		/// <summary>
		/// Initializes a new instance of the <see cref="InvalidItemSlugException"/> class.
		/// </summary>
		public InvalidItemSlugException ( ) {}

		/// <summary>
		/// Initializes a new instance of the <see cref="InvalidItemSlugException"/> class.
		/// </summary>
		/// <param name="message">The message.</param>
		public InvalidItemSlugException ( string message ) : base ( message ) {}

		/// <summary>
		/// Initializes a new instance of the <see cref="InvalidItemSlugException"/> class.
		/// </summary>
		/// <param name="message">The message.</param>
		/// <param name="innerException">The inner exception.</param>
		public InvalidItemSlugException ( string message , Exception innerException ) : base ( message , innerException ) {}
	}
}
