﻿using System;
using Dexter.Domain.Model;

namespace Dexter.Domain.Exceptions {
	/// <summary>
	/// This exception will raise when a error when the <see cref="Role"/> will not fund.
	/// </summary>
	public class RoleNotFoundException : SystemException {
		/// <summary>
		/// Initializes a new instance of the <see cref="RoleNotFoundException"/> class.
		/// </summary>
		public RoleNotFoundException ( ) {}

		/// <summary>
		/// Initializes a new instance of the <see cref="RoleNotFoundException"/> class.
		/// </summary>
		/// <param name="message">The message.</param>
		public RoleNotFoundException ( string message ) : base ( message ) {}

		/// <summary>
		/// Initializes a new instance of the <see cref="RoleNotFoundException"/> class.
		/// </summary>
		/// <param name="message">The message.</param>
		/// <param name="innerException">The inner exception.</param>
		public RoleNotFoundException ( string message , Exception innerException ) : base ( message , innerException ) {}
	}
}
