﻿using System;
using Dexter.Domain.Model;

namespace Dexter.Domain.Exceptions {
	/// <summary>
	/// This exception will raise when a error when the <see cref="User"/> will not fund.
	/// </summary>
	public class UserNotFoundException : SystemException {
		/// <summary>
		/// Initializes a new instance of the <see cref="UserNotFoundException"/> class.
		/// </summary>
		public UserNotFoundException ( ) {}

		/// <summary>
		/// Initializes a new instance of the <see cref="UserNotFoundException"/> class.
		/// </summary>
		/// <param name="message">The message.</param>
		public UserNotFoundException ( string message ) : base ( message ) {}

		/// <summary>
		/// Initializes a new instance of the <see cref="UserNotFoundException"/> class.
		/// </summary>
		/// <param name="message">The message.</param>
		/// <param name="innerException">The inner exception.</param>
		public UserNotFoundException ( string message , Exception innerException ) : base ( message , innerException ) {}
	}
}
