﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		AdvancedFeatues.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            AdvancedFeatues.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion
 
using System;

namespace Dexter.Domain.Model {
	
	/// <summary>
	/// The advanced configuration allows <remarks>Dexter</remarks> to use some features like DataCompression, StripWhiteSpace, etc.
	/// </summary>
	[Serializable]
	public class AdvancedFeatues : DomainEntity {
		internal AdvancedFeatues ( ) {}

		/// <summary>
		/// Gets or sets a value indicating whether data compression should be enabled or not.
		/// </summary>
		/// <value><c>true</c> if the output stream will be compressed; otherwise, <c>false</c>.</value>
		public bool DataCompression { get; set; }

		/// <summary>
		/// Gets or sets a value indicating whether the strip white space should be enabled or not.
		/// </summary>
		/// <value><c>true</c> if white space will be removed from html output; otherwise, <c>false</c>.</value>
		public bool StripWhiteSpace { get; set; }
	}
}
