﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		AntispamConfiguration.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            AntispamConfiguration.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion
 
using System;

namespace Dexter.Domain.Model {
	/// <summary>
	///	A set of information about the <remarks>AntiSpam</remarks> configuration.
	/// </summary>
	[Serializable]
	public class AntispamConfiguration : DomainEntity {

		/// <summary>
		/// 	Initializes a new instance of the <see cref = "AntispamConfiguration" /> class.
		/// </summary>
		internal AntispamConfiguration ( ) {
			ReCaptchaConfiguration = new ReCaptcha ( );
		}

		/// <summary>
		/// 	Gets or sets the akismet API key.
		/// </summary>
		/// <value>The akismet API key.</value>
		public string AkismetApiKey { get; set; }

		/// <summary>
		/// 	Gets or sets the re captcha configuration.
		/// </summary>
		/// <value>The re captcha configuration.</value>
		public ReCaptcha ReCaptchaConfiguration { get; set; }
	}
}
