﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		CommentConfiguration.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            CommentConfiguration.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion
 
using System;

namespace Dexter.Domain.Model {
	/// <summary>
	///		This class contains the comment configuration.
	/// </summary>
	[Serializable]
	public class CommentConfiguration : DomainEntity {
		internal CommentConfiguration ( ) {}

		/// <summary>
		/// Gets or sets the type of the moderation.
		/// </summary>
		/// <value>The type of the moderation.</value>
		public ModerationType ModerationType { get; set; }

		/// <summary>
		/// Gets or sets the day before disable comment.
		/// </summary>
		/// <value>The day before disable comment.</value>
		public int? DayBeforeDisableComment { get; set; }
	}
}
