﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		ElementInListsConfiguration.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            ElementInListsConfiguration.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion
 
using System;

namespace Dexter.Domain.Model {
	///<summary>
	///	This class contains a set of settings about the numebr of element
	///	Dexter should shows.
	///</summary>
	[Serializable]
	public class ElementInListsConfiguration : DomainEntity {
		/// <summary>
		/// 	Initializes a new instance of the <see cref = "ElementInListsConfiguration" /> class.
		/// </summary>
		internal ElementInListsConfiguration ( ) {
			NumberOfElementsInList = 10;
			NumberOfElementsInFeed = 15;
			NumberOfElementsInFeed = 10;
			NumberOfElementsInRelatedPage = 20;
			NumberOfElementsInSearchResult = 20;
		}

		/// <summary>
		/// 	Gets or sets the number of elements to show in blog list.
		/// </summary>
		/// <value>The number of elements in blog list.</value>
		public int NumberOfElementsInList { get; set; }

		/// <summary>
		/// 	Gets or sets the number of elements to show in feed.
		/// </summary>
		/// <value>The number of elements in feed.</value>
		public int NumberOfElementsInFeed { get; set; }

		/// <summary>
		/// 	Gets or sets the number of elements to show in search result.
		/// </summary>
		/// <value>The number of elements in search result.</value>
		public int NumberOfElementsInSearchResult { get; set; }

		/// <summary>
		/// 	Gets or sets the number of elements to show in related page.
		/// </summary>
		/// <value>The number of elements in related page.</value>
		public int NumberOfElementsInRelatedPage { get; set; }
	}
}
