﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		GoogleAnalyticsConfigs.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            GoogleAnalyticsConfigs.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion
 
using System;

namespace Dexter.Domain.Model {
	/// <summary>
	/// Google Analytics Configuration
	/// </summary>
	[Serializable]
	public class GoogleAnalyticsConfigs : DomainEntity {
		internal GoogleAnalyticsConfigs ( ) {}

		internal GoogleAnalyticsConfigs ( string profileID , string username , string password ) {
			ProfileID = profileID;
			Username = username;
			Password = password;
		}

		/// <summary>
		/// Gets or sets the profile ID.
		/// </summary>
		/// <value>The profile ID.</value>
		public string ProfileID { get; set; }

		/// <summary>
		/// Gets or sets the username.
		/// </summary>
		/// <value>The username.</value>
		public string Username { get; set; }

		/// <summary>
		/// Gets or sets the password.
		/// </summary>
		/// <value>The password.</value>
		public string Password { get; set; }
	}
}
