﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		InboxMessage.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            InboxMessage.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion
 
using System;

namespace Dexter.Domain.Model {
	public partial class InboxMessage : EntityBase {
		protected InboxMessage ( ) {}

		/// <summary>
		/// Initializes a new instance of the <see cref="InboxMessage"/> class.
		/// </summary>
		/// <param name="name">The name.</param>
		/// <param name="email">The email.</param>
		/// <param name="subject">The subject.</param>
		/// <param name="message">The message.</param>
		public InboxMessage ( string name , string email , string subject , string message ) {
			Name = name;
			Email = email;
			Subject = subject;
			Message = message;
			MessageDate = DateTime.Now;
		}

		public virtual string Name { get; set; }
		public virtual string Email { get; set; }
		public virtual string Subject { get; set; }
		public virtual string Message { get; set; }
		public virtual bool IsRead { get; set; }
		public virtual DateTime MessageDate { get; set; }
	}
}
