﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		Month.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            Month.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion
 
using System.Globalization;

namespace Dexter.Domain.Model {
	public class Month {
		/// <summary>
		/// Initializes a new instance of the <see cref="Month"/> class.
		/// </summary>
		protected Month ( ) {}

		/// <summary>
		/// 	Initializes a new instance of the <see cref = "Month" /> class.
		/// </summary>
		/// <param name = "count">The count.</param>
		/// <param name = "monthId">The month Id.</param>
		/// <param name = "year">The year.</param>
		public Month ( long count , int monthId , int year ) {
			Count = count;
			MonthID = monthId;
			Year = year;

			var mfi = new DateTimeFormatInfo ( );
			MonthName = mfi.GetMonthName ( monthId );
		}

		/// <summary>
		/// 	Gets or sets the count.
		/// </summary>
		/// <value>The count.</value>
		public long Count { get; private set; }

		/// <summary>
		/// 	Gets or sets the name of the month.
		/// </summary>
		/// <value>The name of the month.</value>
		public string MonthName { get; private set; }

		/// <summary>
		/// 	Gets or sets the month Id.
		/// </summary>
		/// <value>The month Id.</value>
		public int MonthID { get; private set; }

		/// <summary>
		/// 	Gets or sets the year.
		/// </summary>
		/// <value>The year.</value>
		public int Year { get; private set; }
	}
}
