﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		ReCaptcha.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            ReCaptcha.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion
 
using System;

namespace Dexter.Domain.Model {
	/// <summary>
	/// 	This class contains the ReCaptcha configuration.
	/// </summary>
	[Serializable]
	public class ReCaptcha : DomainEntity {
		internal ReCaptcha ( ) {}

		/// <summary>
		/// 	Gets or sets a value indicating whether this <see cref = "ReCaptcha" /> is enable.
		/// </summary>
		/// <value><c>true</c> if enable; otherwise, <c>false</c>.</value>
		public bool Enable { get; set; }

		/// <summary>
		/// 	Gets or sets the theme.
		/// </summary>
		/// <value>The theme.</value>
		public string Theme { get; set; }

		/// <summary>
		/// 	Gets or sets the public key.
		/// </summary>
		/// <value>The public key.</value>
		public string PublicKey { get; set; }

		/// <summary>
		/// 	Gets or sets the private key.
		/// </summary>
		/// <value>The private key.</value>
		public string PrivateKey { get; set; }
	}
}
