﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		SeoConfiguration.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            SeoConfiguration.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion
 
using System;

namespace Dexter.Domain.Model {
	/// <summary>
	/// This class contains a set of information about the SEO (Search Engine Optimization);
	/// Specifically here are stored Title of the page, Description, Keywords and moreover.
	/// </summary>
	[Serializable]
	public class SeoConfiguration : DomainEntity {
		internal SeoConfiguration ( ) {}

		/// <summary>
		/// Gets or sets the default title.
		/// </summary>
		/// <value>The default title.</value>
		public string DefaultTitle { get; set; }

		/// <summary>
		/// Gets the title prefix.
		/// </summary>
		/// <value>The title prefix.</value>
		public string TitlePrefix { get { return DefaultTitle.Cut ( 30 , "..." ); } }

		/// <summary>
		/// Gets or sets the default description.
		/// </summary>
		/// <value>The default description.</value>
		public string DefaultDescription { get; set; }

		/// <summary>
		/// Gets or sets the default key words.
		/// </summary>
		/// <value>The default key words.</value>
		public string[] DefaultKeyWords { get; set; }

		/// <summary>
		/// Gets or sets the copy right.
		/// </summary>
		/// <value>The copy right.</value>
		public string CopyRight { get; set; }
	}
}
