﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		SiteConfiguration.Builder.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            SiteConfiguration.Builder.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion
 
using System;
using System.Net.Mail;
using System.Threading;

namespace Dexter.Domain.Model {
	public partial class SiteConfiguration {

		/// <summary>
		/// Creates a new instance of <see cref="BlogRoll"/>.
		/// </summary>
		/// <returns>A new instance of <see cref="BlogRoll"/></returns>
		public static SiteConfiguration GetDefaultConfiguration ( ) {
			var data = new SiteConfiguration ( );
			data.BlogName = "Dexter";
			data.AdvancedFeatues.DataCompression = false;
			data.AdvancedFeatues.StripWhiteSpace = false;
			data.AntispamConfiguration.AkismetApiKey = string.Empty;
			data.AntispamConfiguration.ReCaptchaConfiguration.PrivateKey = string.Empty;
			data.AntispamConfiguration.ReCaptchaConfiguration.PublicKey = string.Empty;
			data.AntispamConfiguration.ReCaptchaConfiguration.Theme = "white";

			data.SmtpConfiguration.SmtpHost = "localhost";
			data.SmtpConfiguration.Username = string.Empty;
			data.SmtpConfiguration.Port = 25;
			data.SmtpConfiguration.Password = string.Empty;
			data.SmtpConfiguration.UseSSL = false;

			data.CommentConfiguration.ModerationType = ModerationType.First;

			data.GoogleAnalytics.Password = string.Empty;
			data.GoogleAnalytics.Username = string.Empty;
			data.GoogleAnalytics.ProfileID = string.Empty;

			data.NotificationConfiguration.NotificationEmailAddress = "noreply@dexterblogengine.com";
			data.NotificationConfiguration.NotifyNewComment = false;
			data.NotificationConfiguration.NotifyNewTrackback = false;
			data.NotificationConfiguration.SenderEmail = new MailAddress ( "noreply@dexterblogengine.com" , "Dexter Blog Engine" );

			data.Tracking.EnablePingBackReceive = true;
			data.Tracking.EnablePingBackSend = true;
			data.Tracking.EnableReferrerTracking = true;
			data.Tracking.EnableTrackBackReceive = true;
			data.Tracking.EnableTrackBackSend = true;

			data.SeoConfiguration.CopyRight = "Dexter";
			data.SeoConfiguration.DefaultDescription = "Dexter Description";

			data.SeoConfiguration.DefaultKeyWords = new string[] {"Dexter Blog Engine" , "Dexter, Blog" , "Engine"};
			data.SeoConfiguration.DefaultTitle = "Dexter Blog Engine";
			data.TimeZone = TimeZoneInfo.Utc;
			data.Culture = Thread.CurrentThread.CurrentUICulture;
			data.FooterCode = string.Empty;
			data.HeaderCode = string.Empty;
			data.FeedBurnerUrl = string.Empty;
			data.ThemeName = "Fusion";
			data.CultureName = Thread.CurrentThread.CurrentUICulture.Name;
			data.PrincipalAuthor = "Dexter";
			data.TimeZoneId = TimeZoneInfo.Utc.Id;
			data.UrlBuilder.ForceHttps = false;
			data.UrlBuilder.SiteDomain = "dexterv";

			return data;
		}
	}
}
