﻿using Dexter.Dependency;
using Dexter.Dependency.Installation;
using Dexter.Logger.Contracts;

namespace Dexter.Logger.Log4Net.Installer {
	public class Lo4NetInstaller : ILayerInstaller {
		#region ILayerInstaller Members

		/// <summary>
		/// 	Installs all the component needed by the assembly.
		/// </summary>
		/// <param name = "container">The container.</param>
		public void ServiceRegistration ( IDexterContainerRegister container ) {
			container.Register<ILoggerFactory, Log4NetFactory> ( "Log4NetFactory", LifeCycle.Singleton );
			container.Register<ILogger, Log4NetLogger> ( "Log4NetLogger", LifeCycle.Singleton );
		}

		/// <summary>
		/// 	Setups the service.
		/// </summary>
		/// <param name = "container">The container.</param>
		public void ServiceRegistrationComplete ( IDexterContainerResolver container ) { }

		/// <summary>
		/// 	Setups the service.
		/// </summary>
		/// <param name = "container">The container.</param>
		public void ApplicationStarted ( IDexterContainerResolver container ) { }

		#endregion
	}
}