﻿using Dexter.Dependency;
using Dexter.Dependency.Installation;

namespace Dexter.PluginManager.Installer {
	public class LayerInstaller : ILayerInstaller{
		/// <summary>
		/// 	Installs all the component needed by the assembly.
		/// </summary>
		/// <param name = "container">The container.</param>
		public void ServiceRegistration ( IDexterContainerRegister container ) {
			container.Register <IPluginManager , PluginManager> ( "PluginManager" , LifeCycle.Singleton );
			container.Register<IRenderPluginManager, RenderPluginManager> ( "RenderPluginManager", LifeCycle.Singleton );
		}

		/// <summary>
		/// 	Setups the service.
		/// </summary>
		/// <param name = "container">The container.</param>
		public void ServiceRegistrationComplete ( IDexterContainerResolver container ) {}

		/// <summary>
		/// 	Setups the service.
		/// </summary>
		/// <param name = "container">The container.</param>
		public void ApplicationStarted ( IDexterContainerResolver container ) {
		}
	}
}
