﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		ClassPluralizedTableApplier.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            ClassPluralizedTableApplier.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion

using System;
using ConfOrm.Shop.Inflectors;
using Dexter.Repository.NHibernate.Configuration;

namespace Dexter.Repository.NHibernate.ConfORM.DexterNaming {

	internal class ClassPluralizedTableApplier : ConfOrm.Shop.InflectorNaming.ClassPluralizedTableApplier {
		readonly INHibernateConfiguration nHibernateConfiguration;

		/// <summary>
		/// Initializes a new instance of the <see cref="ClassPluralizedTableApplier"/> class.
		/// </summary>
		/// <param name="inflector">The inflector.</param>
		/// <param name="nHibernateConfiguration">The n hibernate configuration.</param>
		public ClassPluralizedTableApplier ( IInflector inflector , INHibernateConfiguration nHibernateConfiguration ) : base ( inflector ) {
			this.nHibernateConfiguration = nHibernateConfiguration;
		}

		/// <summary>
		/// Gets the name of the table.
		/// </summary>
		/// <param name="subject">The subject.</param>
		/// <returns></returns>
		public override string GetTableName ( Type subject ) {
			return string.Concat ( nHibernateConfiguration.DatabaseTablePrefix, base.GetTableName ( subject ) );
		}
	}
}
