﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		NHConfigurationSection.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            NHConfigurationSection.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion

using System;
using System.Configuration;

namespace Dexter.Repository.NHibernate.Configuration {

	/// <summary>
	/// The configuration section will all connection parameters
	/// </summary>
	[Serializable]
	public class NHConfiguration {

		/// <summary>
		/// Gets or sets the name of the connection string.
		/// </summary>
		/// <value>The name of the connection string.</value>
		public string ConnectionString { get; set; }

		/// <summary>
		/// Gets or sets the cache provider <example>NHibernate.Caches.SysCache.SysCacheProvider, NHibernate.Caches.SysCache</example>.
		/// </summary>
		/// <value>The cache provider.</value>
		public string CacheProvider { get; set; }

		/// <summary>
		/// Gets or sets the type of the database <example>MsSql2000, MsSql2005, MsSql2008, MySql and SqlLite</example>
		/// </summary>
		/// <value>The type of the database.</value>
		public string DatabaseType { get; set; }

		/// <summary>
		/// Gets or sets the database schema <example>dbo</example>
		/// </summary>
		/// <value>The database schema.</value>
		public string DatabaseSchema { get; set; }

		/// <summary>
		/// Gets or sets the database table prefix <example>Dexter_</example>
		/// </summary>
		/// <value>The database table prefix.</value>
		public string DatabaseTablePrefix { get; set; }
	}
}
