﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		IConfigurationRepository.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            IConfigurationRepository.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion

using System;
using Dexter.Domain.Model;

namespace Dexter.Repository {
	/// <summary>
	/// 	Rapresents a repository of <see cref="Domain.Model.Configuration"/>.
	/// </summary>
	public interface IConfigurationRepository : IRepository <Domain.Model.Configuration> {
		
		/// <summary>
		/// Saves the specified configuration.
		/// </summary>
		/// <param name="configuration">The configuration.</param>
		///<exception cref="ArgumentNullException"> If <paramref name="configuration"/> is <c>null</c>.</exception>
		void SaveConfiguration(Configuration configuration);
		
		/// <summary>
		/// Retrieve the application configuration
		/// </summary>
		/// <returns>An instance of <see cref="Configuration"/>. It will never be null.</returns>
		Configuration GetConfiguration ( );
	}
}