﻿namespace Dexter.Scheduler {
	/// <summary>
	/// The contract for periodically at certain times or dates jobs.
	/// </summary>
	public interface ICronJob : IJob {
		/// <summary>
		/// The Cron pattern.
		/// </summary>
		/// <remarks>
		///		See this documentation <seealso cref="http://en.wikipedia.org/wiki/Cron"/> or use this tool <seealso cref="http://www.cronmaker.com/"/>.
		/// </remarks>
		/// <value>The cron patter.</value>
		string CronPatter { get; }
	}
}
