﻿using System.Configuration;

namespace Dexter.Search.Lucene.Configuration.OnPremise {
	public class LuceneConfiguration : ILuceneConfiguration {
		static readonly LuceneConfigurationSection section;

		static LuceneConfiguration ( ) {
			section = ConfigurationManager.GetSection ( "dexter/lucene" ) as LuceneConfigurationSection ??  new LuceneConfigurationSection (  );
		}

		public float TitleBoost {
			get { return section.TitleBoost; }
		}

		public float TagsBoost {
			get { return section.TagsBoost; }
		}

		public float BodyBoost {
			get { return section.BodyBoost; }
		}

		public int MinimumDocumentFrequency {
			get { return section.MinimumDocumentFrequency; }
		}

		public int MinimumTermFrequency {
			get { return section.MinimumTermFrequency; }
		}

		public float MinimumScore {
			get { return section.MinimumScore; }
		}
	}
}
