﻿using Dexter.Dependency;
using Dexter.Dependency.Installation;

namespace Dexter.Search.Lucene.Installer {
	public class SearchServiceInstaller : ILayerInstaller{
		/// <summary>
		/// 	Installs all the component needed by the assembly.
		/// </summary>
		/// <param name = "container">The container.</param>
		public void ServiceRegistration ( IDexterContainerRegister container ) {
			container.Register <IIndexService , IndexService> ( "IndexService" , LifeCycle.Singleton );
			container.Register<ISearchService, SearchService> ( "SearchService", LifeCycle.Singleton );
		}

		/// <summary>
		/// 	Setups the service.
		/// </summary>
		/// <param name = "container">The container.</param>
		public void ServiceRegistrationComplete ( IDexterContainerResolver container ) {
			
		}

		/// <summary>
		/// 	Setups the service.
		/// </summary>
		/// <param name = "container">The container.</param>
		public void ApplicationStarted ( IDexterContainerResolver container ) {
			
		}
	}
}
