﻿
namespace Dexter.Services {
	public interface IBackOfficeUrlBuilder {
		
		/// <summary>
		/// 	Gets the pingback url.
		/// </summary>
		/// <example>
		/// 	http://dexterblogengine.com/Admin
		/// </example>
		string Home { get; }

		/// <summary>
		/// 	Gets the new post url.
		/// </summary>
		/// <example>
		/// 	http://dexterblogengine.com/Admin/Page/Edit
		/// </example>
		string NewPage { get; }

		/// <summary>
		/// 	Gets the new post url.
		/// </summary>
		/// <example>
		/// 	http://dexterblogengine.com/Admin/Post/Edit
		/// </example>
		string NewPost { get; }

		/// <summary>
		/// 	Gets the post list url.
		/// </summary>
		/// <example>
		/// 	http://dexterblogengine.com/Admin/Page/
		/// </example>
		string PageList { get; }

		/// <summary>
		/// 	Gets the post list url.
		/// </summary>
		/// <example>
		/// 	http://dexterblogengine.com/Admin/Post/
		/// </example>
		string PostList { get; }

		/// <summary>
		/// 	Gets the post list url.
		/// </summary>
		/// <example>
		/// 	http://dexterblogengine.com/Admin/Category/
		/// </example>
		string CategoryList { get; }

		/// <summary>
		/// 	Gets the new post url.
		/// </summary>
		/// <example>
		/// 	http://dexterblogengine.com/Admin/Category/Edit
		/// </example>
		string NewCategory { get; }

		/// <summary>
		/// 	Gets the post list url.
		/// </summary>
		/// <example>
		/// 	http://dexterblogengine.com/Admin/Account/
		/// </example>
		string UserList { get; }

		/// <summary>
		/// 	Gets the export post url.
		/// </summary>
		/// <example>
		/// 	http://dexterblogengine.com/Backup/Posts
		/// </example>
		string ExportPost { get; }

		/// <summary>
		/// 	Gets the export post url.
		/// </summary>
		/// <example>
		/// 	http://dexterblogengine.com/Backup/ExportConfiguration
		/// </example>
		string ExportConfiguration { get; }

		/// <summary>
		/// 	Gets the export post url.
		/// </summary>
		/// <example>
		/// 	http://dexterblogengine.com/admin/settings/site
		/// </example>
		string SiteConfiguration { get; }

		/// <summary>
		/// 	Gets the export post url.
		/// </summary>
		/// <example>
		/// 	http://dexterblogengine.com/admin/settings/RebuildSearchIndex
		/// </example>
		string RebuildSearchIndex { get; }

		/// <summary>
		/// 	Gets the export post url.
		/// </summary>
		/// <example>
		/// 	http://dexterblogengine.com/admin/settings/PluginSettings
		/// </example>
		string PluginSettings { get; }

		/// <summary>
		/// 	Gets the export post url.
		/// </summary>
		/// <example>
		/// 	http://dexterblogengine.com/admin/statistics/referrers
		/// </example>
		string Referrers { get; }

		/// <summary>
		/// 	Gets the export post url.
		/// </summary>
		/// <example>
		/// 	http://dexterblogengine.com/admin/backup/comments
		/// </example>
		string CommentsExport { get;}

		/// <summary>
		/// 	Gets the export post url.
		/// </summary>
		/// <example>
		/// 	http://dexterblogengine.com/admin/backup/importsPosts
		/// </example>
		string ImportPosts { get;}
	}
}
