﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		IBlogRollService.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            IBlogRollService.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion
 

using System;
using Dexter.Core.EventArgs;
using Dexter.Domain.Model;
using Dexter.Domain.Results;

namespace Dexter.Services
{
	/// <summary>
	/// 	Rapresents the gateway for all service to save, retrieve and manipulate data for <see cref="BlogRoll"/>.
	/// </summary>
	public interface IBlogRollService
	{
		///<summary>
		///	Return a list of BlogRoll with all properties loaded.
		///</summary>
		///<param name = "pageIndex">Index of the page (0 based).</param>
		///<param name = "pageSize">The number of items to retrieve.</param>
		///<returns>An concrete implementation of <see cref="IPagedResult{T}"/>. The result will never be null.</returns>
		IPagedResult<BlogRoll> GetListPaged(int pageIndex, int pageSize);

		///<summary>
		///	Return a list of BlogRoll with all properties loaded.
		///</summary>
		///<param name = "pageIndex">Index of the page (0 based).</param>
		///<param name = "pageSize">The number of items to retrieve.</param>
		///<returns>An concrete implementation of <see cref="IPagedResult{T}"/>. The result will never be null.</returns>
		/// <param name="enableTracking">if set to <c>true</c> the tracking system of the return object will be enable.</param>
		IPagedResult<BlogRoll> GetListPaged(int pageIndex, int pageSize, bool enableTracking);

		/// <summary>
		/// This event will raise when a list of <see cref="BlogRoll"/> will retrieved by the implementation of <see cref="IBlogRollService.GetListPaged(int,int)"/>.
		/// </summary>
		event EventHandler<GenericEventArgs<IPagedResult<BlogRoll>>> BlogRollsRetrieved;
	}
}
