﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		ICategoryUrlBuilder.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            ICategoryUrlBuilder.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion

using Dexter.DataTransferObject;
using Dexter.Domain.Model;

namespace Dexter.Services {
	public interface ICategoryUrlBuilder {
		/// <summary>
		/// Return the detail url of the specified <see cref="Category"/>.
		/// </summary>
		/// <param name = "item">The item.</param>
		/// <example>
		/// 	http://dexterblogengine.com/Categories/Archive/My-Category/
		/// </example>
		string Detail ( Category item );

		/// <summary>
		/// Return the detail url of the specified <see cref="Category"/>.
		/// </summary>
		/// <param name = "item">The item.</param>
		/// <example>
		/// 	http://dexterblogengine.com/Categories/Archive/My-Category/
		/// </example>
		string Detail ( CategoryDto item );


		/// <summary>
		/// Return the feed url of the specified <see cref="Category"/>.
		/// </summary>
		/// <param name="item">The item.</param>
		/// <example>
		/// 	http://dexterblogengine.com/blog/fees/2009/05/19/My-Post/
		/// </example>
		string Feed ( Category item );

		/// <summary>
		/// Return the feed url of the specified <see cref="Category"/>.
		/// </summary>
		/// <param name="item">The item.</param>
		/// <example>
		/// 	http://dexterblogengine.com/blog/fees/2009/05/19/My-Post/
		/// </example>
		string Feed ( CategoryDto item );

		/// <summary>
		/// 	Return the edit url of the specified <see cref = "Post" />.
		/// </summary>
		/// <param name = "item">The item.</param>
		/// <example>
		/// 	http://dexterblogengine.com/Admin/Category/Editor/10/
		/// </example>
		string Edit ( Category item );

		/// <summary>
		/// 	Return the edit url of the specified <see cref = "Post" />.
		/// </summary>
		/// <param name = "item">The item.</param>
		/// <example>
		/// 	http://dexterblogengine.com/Admin/Category/Editor/10/
		/// </example>
		string Edit ( CategoryDto item );

		/// <summary>
		/// 	Return the edit url of the specified <see cref = "Post" />.
		/// </summary>
		/// <param name = "item">The item.</param>
		/// <example>
		/// 	http://dexterblogengine.com/Admin/Category/Editor/10/
		/// </example>
		string Delete ( Category item );

		/// <summary>
		/// 	Return the edit url of the specified <see cref = "Post" />.
		/// </summary>
		/// <param name = "item">The item.</param>
		/// <example>
		/// 	http://dexterblogengine.com/Admin/Category/Editor/10/
		/// </example>
		string Delete ( CategoryDto item );

	}
}
