﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		IConfigurationService.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            IConfigurationService.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion
 

using System;
using Dexter.Domain.Model;

namespace Dexter.Services {
	/// <summary>
	/// 	Rapresents the gateway for all service to save, retrieve and manipulate data for <see cref="SiteConfiguration"/>.
	/// </summary>
	public interface IConfigurationService : IDomainService
	{
		/// <summary>
		/// Return the configuration of Dexter
		/// </summary>
		/// <value>The configuration.</value>
		SiteConfiguration Configuration { get; }

		/// <summary>
		/// Saves the configuration.
		/// </summary>
		/// <param name="configuration">The configuration.</param>
		/// <exception cref="ArgumentNullException"> If <paramref name="configuration"/> is <c>null</c>.</exception>
		void SaveConfiguration ( SiteConfiguration configuration );
	}
}
