﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		IEmailTemplate.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 // 
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion

using System.Collections.Generic;

namespace Dexter.Services {
	/// <summary>
	/// The contract for the email template implementation
	/// </summary>
	public interface IEmailTemplate : ITemplate {
		/// <summary>
		/// 	Gets the raw ubject of the email. It includes all markers like.
		/// 	<example>
		/// 		[SiteName]
		/// 	</example>
		/// </summary>
		/// <value>The subject.</value>
		string RawSubject { get; }

		/// <summary>
		/// 	Gets the raw body of the email. It includes all markers like.
		/// 	<example>
		/// 		[SiteName]
		/// 	</example>
		/// </summary>
		/// <value>The body.</value>
		string RawBody { get; }

		/// <summary>
		/// 	Format the <c>subject</c> of the email.
		/// </summary>
		/// <returns>The formatted subject.</returns>
		string GetFormatedSubject ( IDictionary <string , string> values );

		/// <summary>
		/// 	Format the <c>body</c> of the email.
		/// </summary>
		/// <returns>The formatted body.</returns>
		string GetFormatedBody ( IDictionary<string, string> values );
	}
}
