﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		IPageUrlBuilder.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            IPageUrlBuilder.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion

using Dexter.DataTransferObject;
using Dexter.Domain.Model;

namespace Dexter.Services {
	public interface IPageUrlBuilder {
		/// <summary>
		/// Return the detail url of the specified <see cref="Page"/>.
		/// </summary>
		/// <param name = "item">The item.</param>
		/// <example>
		/// 	http://dexterblogengine.com/My-Page/
		/// </example>
		string Detail ( Page item );

		/// <summary>
		/// Return the detail url of the specified <see cref="Page"/>.
		/// </summary>
		/// <param name = "item">The item.</param>
		/// <example>
		/// 	http://dexterblogengine.com/My-Page/
		/// </example>
		string Detail(PageDto item);

		/// <summary>
		/// Return the detail url of the specified <see cref="PageStructure"/>.
		/// </summary>
		/// <param name = "item">The item.</param>
		/// <example>
		/// 	http://dexterblogengine.com/My-Page/
		/// </example>
		string Detail ( PageStructure item );

		/// <summary>
		/// Return the detail url of the specified <see cref="PageStructure"/>.
		/// </summary>
		/// <param name = "item">The item.</param>
		/// <example>
		/// 	http://dexterblogengine.com/My-Page/
		/// </example>
		string Detail ( PageStructureDto item );

		/// <summary>
		/// Return the print url of the specified <see cref="Page"/>.
		/// </summary>
		/// <param name = "item">The item.</param>
		/// <example>
		/// 	http://dexterblogengine.com/My-Page/Print
		/// </example>
		string Print ( Page item );

		/// <summary>
		/// Return the feed url of the specified <see cref="Page"/>.
		/// </summary>
		/// <param name="item">The item.</param>
		/// <example>
		/// 	http://dexterblogengine.com/My-Page/Feed
		/// </example>
		string Feed ( Page item );

		/// <summary>
		/// Return the statistic url of the specified <see cref="Page"/>.
		/// </summary>
		/// <param name="item">The item.</param>
		/// <example>
		/// 	http://dexterblogengine.com/My-Page/Statistics
		/// </example>
		string Statistics ( Page item );

		/// <summary>
		/// Return the edit url of the specified <see cref="Page"/>.
		/// </summary>
		/// <param name="item">The item.</param>
		/// <example>
		/// 	http://dexterblogengine.com/Admin/Page/Edit/10/
		/// </example>
		string Edit ( Page item );

		/// <summary>
		/// Return the edit url of the specified <see cref="Page"/>.
		/// </summary>
		/// <param name="item">The item.</param>
		/// <example>
		/// 	http://dexterblogengine.com/Admin/Page/Edit/10/
		/// </example>
		string Edit(PageDto item);

		/// <summary>
		/// Return the delete url of the specified <see cref="Page"/>.
		/// </summary>
		/// <param name="item">The item.</param>
		/// <example>
		/// 	http://dexterblogengine.com/Admin/Page/Edit/10/
		/// </example>
		string Delete ( Page item );

		/// <summary>
		/// Return the delete url of the specified <see cref="Page"/>.
		/// </summary>
		/// <param name="item">The item.</param>
		/// <example>
		/// 	http://dexterblogengine.com/Admin/Page/Edit/10/
		/// </example>
		string Delete(PageDto item);
	}
}
