﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		IReferrerService.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            IReferrerService.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion

using System;
using Dexter.Domain.Model;
using Dexter.Domain.Results;

namespace Dexter.Services {
	/// <summary>
	/// 	Rapresents the gateway for all service to save, retrieve and manipulate data for <see cref="Referrer"/>.
	/// </summary>
	public interface IReferrerService {
		///<summary>
		///	Retireve a paged list of all referrers.
		///</summary>
		///<param name = "pageIndex">Index of the page (0 based).</param>
		///<param name = "pageSize">The number of items to retrieve.</param>
		///<returns>An concrete implementation of <see cref="IPagedResult{T}"/>. The result will never be null.</returns>
		IPagedResult<Referrer> GetCompleteList ( int pageIndex, int pageSize);

		///<summary>
		///	Retireve a paged list of all referrers.
		///</summary>
		///<param name = "pageIndex">Index of the page (0 based).</param>
		///<param name = "pageSize">The number of items to retrieve.</param>
		/// <param name = "enableTracking">if set to <c>true</c> the tracking system of the return object will be enable.</param>
		///<returns>An concrete implementation of <see cref="IPagedResult{T}"/>. The result will never be null.</returns>
		IPagedResult<Referrer> GetCompleteList ( int pageIndex, int pageSize, bool enableTracking );

		/// <summary>
		/// Save the passed <see cref="Referrer"/> to the repository
		/// </summary>
		/// <param name="referrer">The referrer.</param>
		/// <returns>An instance of <see cref="VoidAsyncResult"/>. The resul will never be null.</returns>
		IAsyncResult AddReferrerAsync ( Referrer referrer );
	}
}
