﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		PostBinder.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            PostBinder.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel.DataAnnotations;
using System.Web.Mvc;
using Dexter.Web.Mvc.ViewModel.Backoffice.Validators;
using Dexter.Web.Mvc.ViewModel.Resources;

namespace Dexter.Web.Mvc.ViewModel.Backoffice.Binders
{
	public class PostBinder
	{
		public PostBinder ()
		{
			Categories = new Collection<SimplyCategoryBinder> ();
		}

		public int Id { get; set; }

		[Required(ErrorMessageResourceType = typeof(Errors), ErrorMessageResourceName = "RequiredField")]
		public string Title { get; set; }
		public string Abstract { get; set; }
		public string Slug { get; set; }
		public bool BreakOnAggregate { get; set; }
		public bool CommentEnabled { get; set; }

		[DisplayFormat(ApplyFormatInEditMode = true, DataFormatString = "{0:dd MMMM yyyy}")]
		public DateTime PublishDate { get; set; }
		
		public int PublishHour { get; set; }
		public int PublishMinutes { get; set; }

		[SimplyCategoryValidation(ErrorMessageResourceType = typeof(Errors), ErrorMessageResourceName = "CategoryRequired")]
		public ICollection<SimplyCategoryBinder> Categories { get; set; }

		[AllowHtml]
		[Required(ErrorMessageResourceType = typeof(Errors), ErrorMessageResourceName = "RequiredField")]
		public string FormattedBody { get; set; }
		
		public bool Publish { get; set; }

		[Required(ErrorMessageResourceType = typeof(Errors), ErrorMessageResourceName = "RequiredField")]
		public string Tags { get; set; }

		public static PostBinder EmptyInstance()
		{
			return new PostBinder
			       {
			       		PublishDate = DateTime.Now ,
			       		PublishHour = DateTime.Now.Hour ,
			       		PublishMinutes = DateTime.Now.Minute,
						Publish = true,
						CommentEnabled = true
			       };
		}
	}
}
