﻿using System.Web;
using System.Web.Mvc;

namespace Dexter.Web.Mvc.Results
{
	public class ElmahResult : ActionResult
	{
		private readonly string resouceType;

		public ElmahResult(string resouceType)
		{
			this.resouceType = resouceType;
		}

		public override void ExecuteResult(ControllerContext context)
		{
			var factory = new Elmah.ErrorLogPageFactory();
			if (!string.IsNullOrEmpty(resouceType))
			{
				var pathInfo = "." + resouceType;

				context.HttpContext.RewritePath ( "/admin/elmah", pathInfo, context.HttpContext.Request.QueryString.ToString ( ) );
			}

			var handler = factory.GetHandler(HttpContext.Current, null, null, null);

			handler.ProcessRequest(HttpContext.Current);
		}
	}
}