﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		IDexterView.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 // 
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion

using Dexter.Domain.Model;
using Dexter.Services;
using Dexter.Web.Mvc.ResourceCombiner;
using Dexter.Web.Utils;

namespace Dexter.Web.Mvc.ViewPages {
	/// <summary>
	/// 	The base contract for all views
	/// </summary>
	public interface IDexterView {
		/// <summary>
		/// 	Return the instance of <see cref = "IUrlBuilder" />.
		/// </summary>
		/// <value>The U.</value>
		IUrlBuilder U { get; }

		/// <summary>
		/// 	Return the instance of <see cref = "SiteConfiguration" />.
		/// </summary>
		/// <value>The conf.</value>
		SiteConfiguration C { get; }

		/// <summary>
		/// 	Gets the combiner.
		/// </summary>
		/// <value>The combiner.</value>
		ICombiner Combiner { get; }

		/// <summary>
		/// Gets the utils.
		/// </summary>
		/// <value>The utils.</value>
		IWebUtils Utils { get; }

		/// <summary>
		/// Gets a value indicating whether this instance is moderator.
		/// </summary>
		/// <value>
		/// 	<c>true</c> if this instance is moderator; otherwise, <c>false</c>.
		/// </value>
		bool	IsModerator { get; }

		/// <summary>
		/// 	Check if the specified username is the current logged user.
		/// </summary>
		/// <param name = "username">The username.</param>
		bool CurrentuserIsEqualtTo ( string username );
	}
}
