﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		IBloggerApi.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 // 
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion

using CookComputing.XmlRpc;
using Dexter.Web.MetaWeblogApi.Domain;

namespace Dexter.Web.MetaWeblogApi {
	public interface IBloggerApi {
		[XmlRpcMethod ( "blogger.deletePost" , Description = "Deletes a post." )]
		[return: XmlRpcReturnValue ( Description = "Always returns true." )]
		bool deletePost (
			string appKey ,
			string postid ,
			string username ,
			string password ,
			[XmlRpcParameter (
				Description = "Where applicable, this specifies whether the blog "
				              + "should be republished after the post has been deleted." )] bool publish );

		[XmlRpcMethod ( "blogger.getUsersBlogs" ,
			Description = "Returns information on all the blogs a given user "
			              + "is a member." )]
		BlogInfo[] getUsersBlogs (
			string appKey ,
			string username ,
			string password );
	}
}
