﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		RssHeader.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 // 
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion

using System;
using System.Globalization;
using System.Net.Mail;

namespace Dexter.Web.Syndication.Model {
	/// <summary>
	/// 	This class contains a set of information used for the header of RSS feed output.
	/// </summary>
	public class RssHeader {
		/// <summary>
		/// 	Gets or sets the title of the site.
		/// </summary>
		/// <value>The title.</value>
		public string Title { get; set; }

		/// <summary>
		/// 	Gets or sets the link of the site.
		/// </summary>
		/// <value>The link.</value>
		public Uri Link { get; set; }

		/// <summary>
		/// 	Gets or sets the description of the site.
		/// </summary>
		/// <value>The description.</value>
		public string Description { get; set; }

		/// <summary>
		/// 	Gets or sets the copyright of the site.
		/// </summary>
		/// <value>The copyright.</value>
		public string Copyright { get; set; }

		/// <summary>
		/// 	Gets or sets the culture of the site
		/// </summary>
		/// <value>The culture.</value>
		public CultureInfo Culture { get; set; }

		/// <summary>
		/// 	Gets or sets the latest news date of the site.
		/// </summary>
		/// <value>The latest news date.</value>
		public DateTime? LatestNewsDate { get; set; }

		/// <summary>
		/// 	Gets or sets the publish date of the site.
		/// </summary>
		/// <value>The publish date.</value>
		public DateTime? PublishDate { get; set; }

		/// <summary>
		/// 	Gets or sets the editor mail address.
		/// </summary>
		/// <value>The editor mail address.</value>
		public MailAddress EditorMailAddress { get; set; }

		/// <summary>
		/// 	Gets or sets the principal author of the site.
		/// </summary>
		/// <value>The principal author.</value>
		public string EditorName { get; set; }

		/// <summary>
		/// 	Gets or sets the categories of the site.
		/// </summary>
		/// <value>The categories.</value>
		public string[] Categories { get; set; }
	}
}
