﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		RssItem.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 // 
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion

using System;

namespace Dexter.Web.Syndication.Model {
	/// <summary>
	/// 	This class contains a set of information used for every single item of RSS.
	/// </summary>
	public class RssItem {
		/// <summary>
		/// 	Gets or sets the title of the item.
		/// </summary>
		/// <value>The title.</value>
		public string Title { get; set; }

		/// <summary>
		/// 	Gets or sets the description of the item.
		/// </summary>
		/// <value>The description.</value>
		public string Description { get; set; }

		/// <summary>
		/// 	Gets or sets the link of the item.
		/// </summary>
		/// <value>The link.</value>
		public Uri Link { get; set; }

		/// <summary>
		/// 	Gets or sets the author of the item
		/// </summary>
		/// <value>The author.</value>
		public string Author { get; set; }

		/// <summary>
		/// 	Gets or sets the comments link of the item comments.
		/// </summary>
		/// <value>The comments link.</value>
		public Uri CommentsLink { get; set; }

		/// <summary>
		/// 	Gets or sets the publish date of the item.
		/// </summary>
		/// <value>The publish date.</value>
		public DateTime PublishDate { get; set; }

		/// <summary>
		/// 	Gets or sets the categories of the items
		/// </summary>
		/// <value>The categories.</value>
		public string[] Categories { get; set; }
	}
}
