﻿using System;
using Microsoft.ApplicationServer.Caching;
using Rhino.Mocks;

namespace Dexter.Caching.AppFabric.Test.Helpers {
	internal static class CacheProviderHelper {
		//TODO: Use this property for the integration tests.
		internal static DataCache CacheRepository {
			get {
				var cacheConfiguration = new DataCacheFactoryConfiguration ( ) {
					Servers = new DataCacheServerEndpoint[] {
						new DataCacheServerEndpoint ( Environment.MachineName , 22233 ) ,
					},
					SecurityProperties = new DataCacheSecurity ( DataCacheSecurityMode.None, DataCacheProtectionLevel.None )
				};

				return new DataCacheFactory ( cacheConfiguration ).GetDefaultCache ( );
			}
		}

		internal static AppFabricCacheFactory GetFactoryStub() {
			return MockRepository.GenerateStub <AppFabricCacheFactory> ( null , null );
		}
	}
}
