﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		CategoryHelper.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            CategoryHelper.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion

using Dexter.Domain.Model;

namespace Dexter.Repository.NHibernate.Test.Repositories
{
	#region Usings

	using System;




	#endregion

	public static class CategoryHelper
	{
		public static Category AddDefaultCategoryToRepository ( this BaseNHibernateTest testEnvironment )
		{
			var defaultCategory = GetNewCategory ( testEnvironment , null , true );

			testEnvironment.Persist(defaultCategory);

			return defaultCategory;
		}

		public static Category AddNewCategoryToRepository ( this BaseNHibernateTest testEnvironment )
		{
			var defaultCategory = GetNewCategory(testEnvironment, null, false);

			testEnvironment.Persist(defaultCategory);

			return defaultCategory;
		}

		public static Category GetNewCategory ( this BaseNHibernateTest testEnvironment )
		{
			return GetNewCategory ( testEnvironment , null );
		}

		public static Category GetNewCategory ( this BaseNHibernateTest testEnvironment, Category parent )
		{
			return GetNewCategory ( testEnvironment , parent , false );
		}

		public static Category GetNewCategory ( this BaseNHibernateTest testEnvironment, Category parent, bool isDefault )
		{
			var cat = new Category ( Guid.NewGuid ().ToString () , parent )
			          {
						  IsDefaultCategory = isDefault
			          };

			return cat;
		}
	}
}
