﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		CommentHelper.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            CommentHelper.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion
 
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Net.Mail;
using Dexter.Domain.Model;

namespace Dexter.Repository.NHibernate.Test.Repositories
{
	#region Usings

	using System;



	#endregion

	public static class CommentHelper
	{
		public static IList<Comment> AddComments(this Post post, bool approved, int numberOfComments) {
			IList <Comment> comments = new Collection <Comment> ( );

			for ( int i = 0; i < numberOfComments; i++ ) {
				comments.Add ( AddComment ( post , true ) );
			}

			return comments;
		}

		public static Comment AddComment(this Post post, bool approved) {
			var comment = new Comment ( post , "Message" + Guid.NewGuid ( ) , "imperugo" , new MailAddress ( "mail@mydomain.com" ) , new Uri ( "http://www.tostring.it" ) ) {Approved = true};
			((IList<Comment>)post.Comments).Add(comment);

			return comment;
		}

		public static Comment AddNewCommentToRepository ( this BaseNHibernateTest testEnvironment )
		{
			return AddNewCommentToRepository ( testEnvironment , null );
		}

		public static Comment AddNewCommentToRepository ( this BaseNHibernateTest testEnvironment, Item item )
		{
			Comment comment = GetNewComment ( testEnvironment , item );

			testEnvironment.Persist ( comment );

			return comment;
		}

		public static Comment GetNewComment ( this BaseNHibernateTest testEnvironment )
		{
			return GetNewComment ( testEnvironment , null );
		}

		public static Comment GetNewComment ( this BaseNHibernateTest testEnvironment, Item item )
		{
			if ( item == null )
			{
				Category cat = testEnvironment.GetNewCategory ( null , false );
				item = testEnvironment.GetNewPost ( new[] {cat} );
			}

			string message = "Message_" + Guid.NewGuid ();

			return new Comment ( item , message , "imperugo" , new MailAddress("mail@mydomain.com") , new Uri ( "http://www.tostring.it" ) );
		}
	}
}
