﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		DexterSessionFactory.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		22/11/2010
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            DexterSessionFactory.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion

using NHibernate;
using ISessionFactory = Dexter.Repository.NHibernate.SessionFactory.ISessionFactory;

namespace Dexter.Repository.NHibernate.Test.Helpers {
	public class DexterSessionFactory : ISessionFactory {
		readonly ISession session;

		public DexterSessionFactory ( ISession session ) {
			this.session = session;
		}

		#region Implementation of ISessionFactory

		/// <summary>
		/// Prepares the sesson.
		/// </summary>
		/// <param name="isReadOnly">if set to <c>true</c> [is read only].</param>
		public void PrepareSesson ( bool isReadOnly ) {
			
		}

		public ISession GetSession ( ) {
			return session;
		}

		public void CloseCurrentSession ( bool commitIfInTransaction ) {
			if ( session.Transaction != null && session.Transaction.IsActive && commitIfInTransaction ) {
				session.Transaction.Commit ( );
			}

			session.Close ( );
		}

		#endregion
	}
}
