﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		EmailHelper.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            EmailHelper.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion

using Dexter.Domain.Model;

namespace Dexter.Repository.NHibernate.Test.Repositories
{
	using System;
	using System.Collections.Generic;
	using System.Net.Mail;


	internal static class EmailHelper
	{
		public static EmailMessage GetNewEmail ( this BaseNHibernateTest testEnvironment )
		{
			return EmailMessage.CreateNewEmailMessage ( new MailAddress ( "email@mydomain.com" ) , new MailAddress ( "email@mydomain.com" ) , "subject" + Guid.NewGuid () , "body" + Guid.NewGuid () );
		}

		public static EmailMessage GetNewEmail ( this BaseNHibernateTest testEnvironment, MailAddress from, MailAddress to, string subject, string body )
		{
			return EmailMessage.CreateNewEmailMessage ( from , to , subject , body );
		}

		public static EmailMessage AddNewEmailMessageToRepository ( this BaseNHibernateTest testEnvironment )
		{
			var emailMessage = GetNewEmail(testEnvironment);

			testEnvironment.Persist(emailMessage);

			return emailMessage;
		}

		public static IList<EmailMessage> AddNewEmailMessagesToRepository ( this BaseNHibernateTest testEnvironment, int number )
		{
			IList<EmailMessage> returnItem = new List<EmailMessage> ();

			for ( int i = 0; i < number; i++ )
				returnItem.Add ( AddNewEmailMessageToRepository ( testEnvironment ) );

			return returnItem;
		}
	}
}
