﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		PostHelper.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		19/01/2011
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            PostHelper.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion
 
using System;
using System.Collections.Generic;
using System.Threading;
using Dexter.Domain.Model;

namespace Dexter.Repository.NHibernate.Test.Repositories {
	public static class PostHelper {
		public static IList<Post> AddNewPostsToRepository ( this BaseNHibernateTest testEnvironment, Category[] categories, int numberOfElement ) {
			return AddNewPostsToRepository ( testEnvironment , true , categories , numberOfElement );
		}

		public static IList<Post> AddNewPostsToRepository ( this BaseNHibernateTest testEnvironment, bool published, Category[] categories, int numberOfElement ) {
			IList <Post> items = new List <Post> ( );

			for ( int i = 0; i < numberOfElement; i++ ) {
				items.Add ( AddNewPostToRepository ( testEnvironment , null , null , null , null , published , DateTime.Now , categories ) );
			}

			return items;
		}

		public static Post AddNewPostToRepository ( this BaseNHibernateTest testEnvironment, Category[] categories ) {
			return AddNewPostToRepository ( testEnvironment , null , null , null , null , true , DateTime.Now , categories );
		}

		public static Post AddNewPostToRepository ( this BaseNHibernateTest testEnvironment, string title, string slug, string messageAbstract, string body, bool published, DateTime publishDate, Category[] categories ) {
			Post post = GetNewPost ( testEnvironment , title , slug , messageAbstract , body , published , publishDate , categories );

			testEnvironment.Persist ( post );

			return post;
		}

		public static Post GetNewPost ( this BaseNHibernateTest testEnvironment, Category[] categories ) {
			return GetNewPost ( testEnvironment , null , null , null , null , true , DateTime.Now , categories );
		}

		public static Post GetNewPost ( this BaseNHibernateTest testEnvironment, string title, string slug, string messageAbstract, string body, bool published, DateTime publishDate, Category[] categories ) {
			var post = new Post ( ) {
				Id = 0 ,
				Title = title ?? Guid.NewGuid ( ).ToString ( ) ,
				Abstract = messageAbstract ?? Guid.NewGuid ( ).ToString ( ) ,
				FormattedBody = body ?? Guid.NewGuid ( ).ToString ( ) ,
				Categories = categories ,
				PublishDate = publishDate ,
				Username = Thread.CurrentPrincipal.Identity.Name ,
				Slug = slug ?? Guid.NewGuid ( ).ToString ( ),
			};

			if(published)
				post.Publish (  );

			return post;
		}
	}
}
