﻿
using System;
using System.Collections.Generic;
using System.Linq;
using Dexter.Repository.NHibernate.ConfORM;
using NHibernate.Cfg.MappingSchema;
using NUnit.Framework;
using SharpTestsEx;

namespace Dexter.Repository.NHibernate.Test {
	[TestFixture]
	public class MappingTest : BaseNHibernateTest {
		public MappingTest ( ) : base ( false ) { }

		[Test, Explicit]
		public void WriteAllXmlMapping ( ) {
			Executing.This ( ( ) =>
			{
				IEnumerable<HbmMapping> mappings = GetMappings ( );

				Console.WriteLine ( "Found {0} mapping", mappings.Count ( ) );

				foreach (HbmMapping hbmMapping in mappings) {
					string className = GetClassName ( hbmMapping );
					string document = hbmMapping.Serialize ( );
					Console.WriteLine ( "------------------------" + className + ( "------------------------" ) );
					Console.WriteLine ( );
					Console.Write ( document );
					Console.WriteLine ( );
					Console.WriteLine ( "------------------------" + className + ( "------------------------" ) );
					Console.WriteLine ( );
					Console.WriteLine ( );
				}
			} )
			.Should ( )
			.NotThrow ( );
		}

		protected IEnumerable<HbmMapping> GetMappings ( ) {
			var domainMapper = new DomainMapper ( base.NHelper.Configuration, base.NHibernateEnvironmentConfiguration );
			return domainMapper.Mapper.CompileMappingForEach ( domainMapper.DomainEntities );
		}

		protected HbmMapping GetMapping ( ) {
			var domainMapper = new DomainMapper ( base.NHelper.Configuration, base.NHibernateEnvironmentConfiguration );
			return domainMapper.Mapper.CompileMappingFor ( domainMapper.DomainEntities );
		}

		static string GetClassName ( HbmMapping hbmMapping ) {
			string name = "Unknown";
			HbmClass rc = hbmMapping.RootClasses.FirstOrDefault ( );
			if (rc != null) {
				name = rc.Name;
			}

			HbmSubclass sc = hbmMapping.SubClasses.FirstOrDefault ( );
			if (sc != null) {
				name = sc.Name;
			}

			HbmJoinedSubclass jc = hbmMapping.JoinedSubclasses.FirstOrDefault ( );
			if (jc != null) {
				name = jc.Name;
			}

			HbmUnionSubclass uc = hbmMapping.UnionSubclasses.FirstOrDefault ( );
			if (uc != null) {
				name = uc.Name;
			}

			return name;
		}
	}
}
