﻿ #region Disclaimer/Info
 
 /////////////////////////////////////////////////////////////////////////////////////////////////
 //
 //   File:		BlogRollServiceTest.cs
 //   Website:		http://dexterblogengine.com/
 //   Authors:		http://dexterblogengine.com/About.ashx
 //   Rev:		1
 //   Created:		28/11/2010
 //   Last edit:		19/01/2011
 //   License:		GNU Library General Public License (LGPL)
 //   File:            BlogRollServiceTest.cs
 //   For updated news and information please visit http://dexterblogengine.com/
 //   Dexter is hosted to Codeplex at http://dexterblogengine.codeplex.com
 //   For any question contact info@dexterblogengine.com
 //
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 #endregion

using Dexter.Dependency;
using Dexter.Logger.Concretes;
using Dexter.Logger.Contracts;
using Dexter.Repository;
using NUnit.Framework;
using Rhino.Mocks;
using SharpTestsEx;

namespace Dexter.Services.Implementation.Test
{
	[TestFixture]
	public class BlogRollServiceTest {
		ILogger stubLogger;

		[TestFixtureSetUp]
		public void FixtureSetUp ( ) {
			stubLogger = MockRepository.GenerateStub<ILogger> ( );
		}

		[Test]
		public void GetListPaged_WithValidParameters_ShouldInvokeBlogRollRetrievedEvent() {
			bool actual = false;

			var stub = MockRepository.GenerateStub <IBlogRollRepository> ( );
			IBlogRollService sut = new BlogRollService ( stubLogger, stub );

			stub.Expect ( x => x.GetListPaged ( 1 , 1 ) ).Return ( null );

			sut.BlogRollsRetrieved += ( s , e ) => actual = true;

			sut.GetListPaged ( 1 , 1 );

			actual.Should().Be.True();
		}
	}
}
