﻿using System;
using System.IO;
using System.Linq;

namespace Dexter.Storage.FileSystem.Test {
	internal static class StorageHelper {
		internal static IStorageFolder GetFolder (IStorageProvider storageProvider, string path ) {
			return storageProvider.ListFolders ( Path.GetDirectoryName ( path ) )
				.SingleOrDefault ( x => string.Equals ( x.GetName ( ), Path.GetFileName ( path ), StringComparison.OrdinalIgnoreCase ) );
		}

		internal static IStorageFile GetFile ( IStorageProvider storageProvider,string path ) {
			try {
				return storageProvider.GetFile ( path );
			}
			catch (FileNotFoundException) {
				return null;
			}
		}
	}
}
